GKC = {};
local f = CreateFrame("Frame");
local MyFrame = CreateFrame("Frame");
MyFrame:SetMovable(true);
MyFrame:EnableMouse(true);
MyFrame:RegisterForDrag("LeftButton");
MyFrame:SetScript("OnDragStart", MyFrame.StartMoving);
MyFrame:SetScript("OnDragStop", MyFrame.StopMovingOrSizing);
MyFrame:ClearAllPoints();
MyFrame:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", edgeSize = 10});
MyFrame:SetHeight(105);
MyFrame:SetWidth(150);
 
MyFrame.text = MyFrame:CreateFontString(nil, "BACKGROUND", "GameFontNormal");
MyFrame.text:SetPoint("TOPLEFT",20,-20);
MyFrame.text:SetFont("Fonts\\FRIZQT__.TTF", 11);
MyFrame.text:SetTextColor(1,1,1,1);
MyFrame.text:SetJustifyH("LEFT");

MyFrame:SetPoint("TOPLEFT", 25, -50);
MyFrame:Hide();

-- WEAK AURAS CONFLICT WARNING FRAME
local editbox = ChatEdit_ChooseBoxForSend(DEFAULT_CHAT_FRAME);
local FirstFrame = CreateFrame("Frame");
FirstFrame:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", edgeSize = 10});
FirstFrame:SetHeight(137);
FirstFrame:SetWidth(300);

FirstFrame.text = FirstFrame:CreateFontString(nil, "BACKGROUND", "GameFontNormal");
FirstFrame.text:SetPoint("CENTER",0,0);
FirstFrame.text:SetFont("Fonts\\FRIZQT__.TTF", 11);
FirstFrame.text:SetTextColor(1,1,1,1);
FirstFrame.text:SetJustifyH("LEFT");
FirstFrame.text:SetText("It appears that you still have the\nWeak Auras version of this addon installed.\nBefore this new version can be initialized,\nyou must delete the Weak Auras version.\n\nWhen you have done this,\nclick the button below to reload your UI.");

FirstFrame.btn = CreateFrame("Button",nil,FirstFrame,"UIPanelButtonTemplate");
FirstFrame.btn:SetWidth(80);
FirstFrame.btn:SetHeight(22);
FirstFrame.btn:SetText("Reload UI");
FirstFrame.btn:SetPoint("BOTTOM",0,5);
FirstFrame.btn:SetScript("OnClick",function()
	ChatEdit_ActivateChat(editbox);
    editbox:SetText("/console reloadui");
    ChatEdit_OnEnterPressed(editbox);
end);
FirstFrame:SetPoint("CENTER",0,0);
FirstFrame:Hide();


--Global Variables
GKC.isInZone = false;
GKC.initZone = '';
GKC.inCombat = false;
GKC.delayFaction = '';
GKC.factionType = '';
GKC.player = {
	['level'] = UnitLevel('player'),
	['name'] = UnitName('player'),
	['first'] = false
}
GKC.zones = {
	--BOTANI ZONES
	['Everbloom Wilds'] = "botani",
	['Lost Veil Anzu'] = "botani",
	--OGRE ZONES
	['Gorian Proving Grounds'] = "ogre",
	['Stonefury Cliffs'] = "ogre",
	["Tor'goroth's Tooth"] = "ogre",
	--IRON HORDE ZONES
	['Iron Siegeworks'] = "iHorde",
	["Mok'gol Watchpost"] = "iHorde",
	['The Pit'] = "iHorde",
	--SHADOWMOON ZONES
	['Darktide Roost'] = "shadowmoon",
	['Pillars of Fate'] = "shadowmoon",
	["Socrethar's Rise"] = "shadowmoon",
	['Skettis'] = "shadowmoon",
	--SHADOW COUNCIL ZONES
	["Beacon of Sha'tar"] = "council",
	['Heart of Shattrath'] = "council",
	["Sha'tar Way Station"] = "council",
	["Sha'tari Anchorage"] = "council",
	["Sha'tari Skymesa"] = "council",
	['Shattrath City'] = "council",
	['Shattrath City Center'] = "council",
	['Shattrath Harbor'] = "council",
	['Shattrath Overlook'] = "council",
	['Shattrath Port Authority'] = "council",
	['Shattrath Residential District'] = "council",
	['Skymesa Great Hall'] = "council",
	['Skymesa Inn'] = "council",
	['Skymesa Overlook'] = "council",
	['Skymesa Palisade'] = "council",
	['Skymesa Ritual Chamber'] = "council",
	--GOREN ZONES
	['Broken Precipice'] = "goren",
	['Magnarok'] = "goren"
};

GKC.factions = {
	['botani'] = {
		['kills'] = 0,
		['start'] = 0,
		['old'] = 0,
		['new'] = 0,
		['diff'] = 0
	},
	['goren'] = {
		['kills'] = 0,
		['start'] = 0,
		['old'] = 0,
		['new'] = 0,
		['diff'] = 0
	},
	['ogre'] = {
		['kills'] = 0,
		['start'] = 0,
		['old'] = 0,
		['new'] = 0,
		['diff'] = 0
	},
	['shadowmoon'] = {
		['kills'] = 0,
		['start'] = 0,
		['old'] = 0,
		['new'] = 0,
		['diff'] = 0
	},
	['council'] = {
		['kills'] = 0,
		['start'] = 0,
		['old'] = 0,
		['new'] = 0,
		['diff'] = 0
	},
	['iHorde'] = {
		['kills'] = 0,
		['start'] = 0,
		['old'] = 0,
		['new'] = 0,
		['diff'] = 0
	}
}

f:RegisterEvent("PLAYER_LOGIN");
f:RegisterEvent("ZONE_CHANGED");
f:RegisterEvent("QUEST_ACCEPTED");
f:RegisterEvent("QUEST_REMOVED");

function GKC.CombatKill(e,...)
	if (GKC.player['first'] == false) then -- Prevent code from running if Weak Auras version is installed
		local arg2 = select(2,...); --Event Type
		local arg9 = select(9,...); --Destination Name
		local isPetKill = false;
		
		if (arg2 == "UNIT_DIED") then
			local pName = UnitName('playerpet') or '';
			
			if (arg9 == pName) then
				isPetKill = true; 
			end
		end
		if ((arg2 == "PARTY_KILL" or isPetKill) and GKC.player['level'] == 100 and (GKC.isInZone == true or (GKC.isInZone == false and GKC.inCombat == true))) then
			local fZone = GKC.factionType;
			GKC.factions[fZone]['kills'] = (GKC.factions[fZone]['kills'] + 1) or 1;
			GKC.factions[fZone]['new'] = GKC.factions[fZone]['kills'] - GKC.factions[fZone]['start'];
			GKC_SavedChar['factions'][fZone] = GKC.factions[fZone]['kills'];
			
			MyFrame.text:SetText("Botani - "..GKC.factions['botani']['kills'].."\nOgre - "..GKC.factions['ogre']['kills'].."\nIron Horde - "..GKC.factions['iHorde']['kills'].."\nShadowmoon - "..GKC.factions['shadowmoon']['kills'].."\nShadow Council - "..GKC.factions['council']['kills'].."\nGoren - "..GKC.factions['goren']['kills'])
		end
	end
end

function GKC.Initialize(e)
	--CHECK FOR OLD WEAK AURAS VERSION OF THIS ADDON
	if (WeakAurasSaved ~= nil and WeakAurasSaved['displays']['MOB_KILLS_LOAD'] ~= nil) then
		GKC.player['first'] = true;
		FirstFrame:Show();
	end
	
	if (GKC.player['first'] == false) then -- Prevent code from running if Weak Auras version is installed
		if (GKC_SavedChar == nil) then
			GKC_SavedChar = {};
			GKC_SavedChar['factions'] = {};
		end
		--SET BOTANI GLOBALS
		GKC_SavedChar['factions']['botani'] = GKC_SavedChar['factions']['botani'] or 0;
		GKC.factions['botani']['kills']	= GKC_SavedChar['factions']['botani']  or 0;
		GKC.factions['botani']['start'] = GKC_SavedChar['factions']['botani']  or 0;
		GKC.factions['botani']['old'] = 0;
		GKC.factions['botani']['new'] = 0;
		GKC.factions['botani']['diff'] = 0;
		
		--SET OGRE GLOBALS
		GKC_SavedChar['factions']['ogre'] = GKC_SavedChar['factions']['ogre'] or 0;
		GKC.factions['ogre']['kills'] = GKC_SavedChar['factions']['ogre']  or 0;
		GKC.factions['ogre']['start'] = GKC_SavedChar['factions']['ogre']  or 0;
		GKC.factions['ogre']['old'] = 0;
		GKC.factions['ogre']['new'] = 0;
		GKC.factions['ogre']['diff'] = 0;
		
		--SET SHADOWMOON CLAN GLOBALS
		GKC_SavedChar['factions']['shadowmoon'] = GKC_SavedChar['factions']['shadowmoon'] or 0;
		GKC.factions['shadowmoon']['kills'] = GKC_SavedChar['factions']['shadowmoon'] or 0;
		GKC.factions['shadowmoon']['start'] = GKC_SavedChar['factions']['shadowmoon'] or 0;
		GKC.factions['shadowmoon']['old'] = 0;
		GKC.factions['shadowmoon']['new'] = 0;
		GKC.factions['shadowmoon']['diff'] = 0;
		
		--SET SHADOW COUNCIL GLOBALS
		GKC_SavedChar['factions']['council'] = GKC_SavedChar['factions']['council'] or 0;
		GKC.factions['council']['kills'] = GKC_SavedChar['factions']['council'] or 0;
		GKC.factions['council']['start'] = GKC_SavedChar['factions']['council'] or 0;
		GKC.factions['council']['old'] = 0;
		GKC.factions['council']['new'] = 0;
		GKC.factions['council']['diff'] = 0;
		
		--SET GOREN GLOBALS
		GKC_SavedChar['factions']['goren'] = GKC_SavedChar['factions']['goren'] or 0;
		GKC.factions['goren']['kills'] = GKC_SavedChar['factions']['goren'] or 0;
		GKC.factions['goren']['start'] = GKC_SavedChar['factions']['goren'] or 0;
		GKC.factions['goren']['old'] = 0;
		GKC.factions['goren']['new'] = 0;
		GKC.factions['goren']['diff'] = 0;
		
		--SET IRON HORDE GLOBALS
		GKC_SavedChar['factions']['iHorde'] = GKC_SavedChar['factions']['iHorde'] or 0;
		GKC.factions['iHorde']['kills'] = GKC_SavedChar['factions']['iHorde'] or 0;
		GKC.factions['iHorde']['start'] = GKC_SavedChar['factions']['iHorde'] or 0;
		GKC.factions['iHorde']['old'] = 0;
		GKC.factions['iHorde']['new'] = 0;
		GKC.factions['iHorde']['diff'] = 0;

		MyFrame.text:SetText("Botani - "..GKC.factions['botani']['kills'].."\nOgre - "..GKC.factions['ogre']['kills'].."\nIron Horde - "..GKC.factions['iHorde']['kills'].."\nShadowmoon - "..GKC.factions['shadowmoon']['kills'].."\nShadow Council - "..GKC.factions['council']['kills'].."\nGoren - "..GKC.factions['goren']['kills'])
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00 Sweetsour's Garrison Invasion Kill Counter v1.0 Successfully Loaded!");
	end
end

function GKC.UpdateZone()
	local subZone = GetSubZoneText();
	if (subZone == '') then
		subZone = GetMinimapZoneText();
	end
	for key,value in pairs(GKC.zones) do
		if (key == subZone) then
			GKC.factionType = value;
			GKC.isInZone = true;
			break;
		else
			GKC.isInZone = false;
		end
	end
	if (GKC.isInZone) then
		MyFrame:Show();
		f:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
		f:RegisterEvent("PLAYER_REGEN_DISABLED");
		f:RegisterEvent("PLAYER_REGEN_ENABLED");
	else
		if (GKC.inCombat == false) then
			f:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
			f:UnregisterEvent("PLAYER_REGEN_DISABLED");
			f:UnregisterEvent("PLAYER_REGEN_ENABLED");
			GKC.factionType = '';
			MyFrame:Hide();
		end
	end
end

function GKC.FactionUtilities(e,...)
	if (GKC.player['first'] == false) then -- Prevent code from running if Weak Auras version is installed
		local arg1 = select(2,...);
		
		if (arg1 == 36650 or arg1 == 36623) then
			GKC.factions['ogre']['kills'] = 0;
			GKC.factions['ogre']['new'] = 0;
			GKC_SavedChar['factions']['ogre'] = 0;
		end
		
		if (arg1 == 36830 or arg1 == 36831) then
			GKC.factions['council']['kills'] = 0;
			GKC.factions['council']['new'] =  0;
			GKC_SavedChar['factions']['council'] = 0;    
		end
		
		if (arg1 == 36412 or arg1 == 36414) then
			GKC.factions['shadowmoon']['kills'] = 0;
			GKC.factions['shadowmoon']['new'] = 0;
			GKC_SavedChar['factions']['shadowmoon'] = 0;    
		end
		
		if (arg1 == 36171 or arg1 == 36653) then
			GKC.factions['botani']['kills'] = 0;
			GKC.factions['botani']['new'] = 0;
			GKC_SavedChar['factions']['botani'] = 0;    
		end
		
		if (arg1 == 35142 or arg1 == 36376) then
			GKC.factions['goren']['kills'] = 0;
			GKC.factions['goren']['new'] = 0;
			GKC_SavedChar['factions']['goren'] = 0;    
		end
		
		if (arg1 == 35935 or arg1 == 36655) then
			GKC.factions['iHorde']['kills'] = 0;
			GKC.factions['iHorde']['new'] = 0;
			GKC_SavedChar['factions']['iHorde'] = 0;    
		end
	end
end

function GKC.CombatStart(e)
	if ((e == "PLAYER_REGEN_ENABLED" and GKC.inCombat == true) or (GKC.isInZone == true and GKC.player['first'] == false)) then
		local fZone = GKC.factionType;
		if (e == "PLAYER_REGEN_DISABLED") then
			GKC.inCombat = true;
			GKC.factions[fZone]['old'] = GKC.factions[fZone]['kills']; 
		end
		
		if (e == "PLAYER_REGEN_ENABLED") then
			GKC.inCombat = false;
			local fMsg = '';
			if (GKC.factionType == "botani") then
				fMsg = "BOTANI";
			elseif (GKC.factionType == "ogre") then
				fMsg = "OGRE";
			elseif (GKC.factionType == "goren") then
				fMsg = "GOREN";
			elseif (GKC.factionType == "council") then	
				fMsg = "SHADOW COUNCIL";
			elseif (GKC.factionType == "shadowmoon") then
				fMsg = "SHADOWMOON CLAN";
			elseif (GKC.factionType == "iHorde") then
				fMsg = "IRON HORDE";
			end
			GKC.factions[fZone]['diff'] = GKC.factions[fZone]['kills'] - GKC.factions[fZone]['old'];        
			DEFAULT_CHAT_FRAME:AddMessage("|cFF3399FF +"..string.format(GKC.factions[fZone]['diff']).." "..fMsg);  
		end
	end
end

f:SetScript("OnEvent", function(self,event,...)
	if (event == "COMBAT_LOG_EVENT_UNFILTERED") then
		GKC.CombatKill(event,...);
	elseif (event == "PLAYER_LOGIN") then
		GKC.Initialize(event);
		GKC.UpdateZone();
	elseif (event == "QUEST_ACCEPTED") then
		GKC.FactionUtilities(event,...);
	elseif (event == "PLAYER_REGEN_ENABLED" and GKC.inCombat == true and GKC.isInZone == false) then
		GKC.CombatStart(event);
		GKC.UpdateZone();
	elseif (event == "PLAYER_REGEN_DISABLED" or event == "PLAYER_REGEN_ENABLED") then
		GKC.CombatStart(event);
	elseif (event == "ZONE_CHANGED") then
		GKC.UpdateZone();
	end
end);

SLASH_GKCADDON1 = '/gkc';
function SlashCmdList.GKCADDON(msg, editbox)
	if (GKC.player['first']) then -- Prevent code from running if Weak Auras version is installed
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00 You cannot use this addon until you delete the Weak Auras Version");
	else
		if (msg == 'show') then
			MyFrame:Show();
		elseif (msg == "hide") then
			MyFrame:Hide();
		elseif (msg == "session") then
			local sessionMsg = '';
			
			sessionMsg = "--SESSION TOTALS--\nBOTANI: "..GKC.factions['botani']['new'].."\nOGRE: "..GKC.factions['ogre']['new'].."\nIRON HORDE: "..GKC.factions['iHorde']['new'].."\nSHADOWMOON: "..GKC.factions['shadowmoon']['new'].."\nSHADOW COUNCIL: "..GKC.factions['council']['new'].."\nGOREN: "..GKC.factions['goren']['new'];

			DEFAULT_CHAT_FRAME:AddMessage("|cFF3399FF "..sessionMsg);
		elseif (msg == '' or msg == 'help') then
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFFFF  Garrison Kill Counter Help\n/gkc show - Manually show tracker window\n/gkc hide - Manually hide tracker window\n/gkc session - Show totals for this session");
		
		end
	end
end